/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the RunExtractionRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &RunExtractionRequest{}

// RunExtractionRequest struct for RunExtractionRequest
type RunExtractionRequest struct {
	Url   NullableString `json:"url,omitempty"`
	Limit NullableString `json:"limit,omitempty"`
	// A \"Y-m-d\" formatted value
	DateFrom NullableString `json:"dateFrom,omitempty"`
	// A \"Y-m-d\" formatted value
	DateTo NullableString `json:"dateTo,omitempty"`
	// A \"1d1\" formatted value
	DateRangeExpression NullableString `json:"dateRangeExpression,omitempty"`
	StorageStrategy     NullableString `json:"storageStrategy,omitempty"`
}

// NewRunExtractionRequest instantiates a new RunExtractionRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRunExtractionRequest() *RunExtractionRequest {
	this := RunExtractionRequest{}
	return &this
}

// NewRunExtractionRequestWithDefaults instantiates a new RunExtractionRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRunExtractionRequestWithDefaults() *RunExtractionRequest {
	this := RunExtractionRequest{}
	return &this
}

// GetUrl returns the Url field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RunExtractionRequest) GetUrl() string {
	if o == nil || IsNil(o.Url.Get()) {
		var ret string
		return ret
	}
	return *o.Url.Get()
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RunExtractionRequest) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Url.Get(), o.Url.IsSet()
}

// HasUrl returns a boolean if a field has been set.
func (o *RunExtractionRequest) HasUrl() bool {
	if o != nil && o.Url.IsSet() {
		return true
	}

	return false
}

// SetUrl gets a reference to the given NullableString and assigns it to the Url field.
func (o *RunExtractionRequest) SetUrl(v string) {
	o.Url.Set(&v)
}

// SetUrlNil sets the value for Url to be an explicit nil
func (o *RunExtractionRequest) SetUrlNil() {
	o.Url.Set(nil)
}

// UnsetUrl ensures that no value is present for Url, not even an explicit nil
func (o *RunExtractionRequest) UnsetUrl() {
	o.Url.Unset()
}

// GetLimit returns the Limit field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RunExtractionRequest) GetLimit() string {
	if o == nil || IsNil(o.Limit.Get()) {
		var ret string
		return ret
	}
	return *o.Limit.Get()
}

// GetLimitOk returns a tuple with the Limit field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RunExtractionRequest) GetLimitOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Limit.Get(), o.Limit.IsSet()
}

// HasLimit returns a boolean if a field has been set.
func (o *RunExtractionRequest) HasLimit() bool {
	if o != nil && o.Limit.IsSet() {
		return true
	}

	return false
}

// SetLimit gets a reference to the given NullableString and assigns it to the Limit field.
func (o *RunExtractionRequest) SetLimit(v string) {
	o.Limit.Set(&v)
}

// SetLimitNil sets the value for Limit to be an explicit nil
func (o *RunExtractionRequest) SetLimitNil() {
	o.Limit.Set(nil)
}

// UnsetLimit ensures that no value is present for Limit, not even an explicit nil
func (o *RunExtractionRequest) UnsetLimit() {
	o.Limit.Unset()
}

// GetDateFrom returns the DateFrom field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RunExtractionRequest) GetDateFrom() string {
	if o == nil || IsNil(o.DateFrom.Get()) {
		var ret string
		return ret
	}
	return *o.DateFrom.Get()
}

// GetDateFromOk returns a tuple with the DateFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RunExtractionRequest) GetDateFromOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DateFrom.Get(), o.DateFrom.IsSet()
}

// HasDateFrom returns a boolean if a field has been set.
func (o *RunExtractionRequest) HasDateFrom() bool {
	if o != nil && o.DateFrom.IsSet() {
		return true
	}

	return false
}

// SetDateFrom gets a reference to the given NullableString and assigns it to the DateFrom field.
func (o *RunExtractionRequest) SetDateFrom(v string) {
	o.DateFrom.Set(&v)
}

// SetDateFromNil sets the value for DateFrom to be an explicit nil
func (o *RunExtractionRequest) SetDateFromNil() {
	o.DateFrom.Set(nil)
}

// UnsetDateFrom ensures that no value is present for DateFrom, not even an explicit nil
func (o *RunExtractionRequest) UnsetDateFrom() {
	o.DateFrom.Unset()
}

// GetDateTo returns the DateTo field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RunExtractionRequest) GetDateTo() string {
	if o == nil || IsNil(o.DateTo.Get()) {
		var ret string
		return ret
	}
	return *o.DateTo.Get()
}

// GetDateToOk returns a tuple with the DateTo field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RunExtractionRequest) GetDateToOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DateTo.Get(), o.DateTo.IsSet()
}

// HasDateTo returns a boolean if a field has been set.
func (o *RunExtractionRequest) HasDateTo() bool {
	if o != nil && o.DateTo.IsSet() {
		return true
	}

	return false
}

// SetDateTo gets a reference to the given NullableString and assigns it to the DateTo field.
func (o *RunExtractionRequest) SetDateTo(v string) {
	o.DateTo.Set(&v)
}

// SetDateToNil sets the value for DateTo to be an explicit nil
func (o *RunExtractionRequest) SetDateToNil() {
	o.DateTo.Set(nil)
}

// UnsetDateTo ensures that no value is present for DateTo, not even an explicit nil
func (o *RunExtractionRequest) UnsetDateTo() {
	o.DateTo.Unset()
}

// GetDateRangeExpression returns the DateRangeExpression field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RunExtractionRequest) GetDateRangeExpression() string {
	if o == nil || IsNil(o.DateRangeExpression.Get()) {
		var ret string
		return ret
	}
	return *o.DateRangeExpression.Get()
}

// GetDateRangeExpressionOk returns a tuple with the DateRangeExpression field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RunExtractionRequest) GetDateRangeExpressionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DateRangeExpression.Get(), o.DateRangeExpression.IsSet()
}

// HasDateRangeExpression returns a boolean if a field has been set.
func (o *RunExtractionRequest) HasDateRangeExpression() bool {
	if o != nil && o.DateRangeExpression.IsSet() {
		return true
	}

	return false
}

// SetDateRangeExpression gets a reference to the given NullableString and assigns it to the DateRangeExpression field.
func (o *RunExtractionRequest) SetDateRangeExpression(v string) {
	o.DateRangeExpression.Set(&v)
}

// SetDateRangeExpressionNil sets the value for DateRangeExpression to be an explicit nil
func (o *RunExtractionRequest) SetDateRangeExpressionNil() {
	o.DateRangeExpression.Set(nil)
}

// UnsetDateRangeExpression ensures that no value is present for DateRangeExpression, not even an explicit nil
func (o *RunExtractionRequest) UnsetDateRangeExpression() {
	o.DateRangeExpression.Unset()
}

// GetStorageStrategy returns the StorageStrategy field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RunExtractionRequest) GetStorageStrategy() string {
	if o == nil || IsNil(o.StorageStrategy.Get()) {
		var ret string
		return ret
	}
	return *o.StorageStrategy.Get()
}

// GetStorageStrategyOk returns a tuple with the StorageStrategy field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RunExtractionRequest) GetStorageStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.StorageStrategy.Get(), o.StorageStrategy.IsSet()
}

// HasStorageStrategy returns a boolean if a field has been set.
func (o *RunExtractionRequest) HasStorageStrategy() bool {
	if o != nil && o.StorageStrategy.IsSet() {
		return true
	}

	return false
}

// SetStorageStrategy gets a reference to the given NullableString and assigns it to the StorageStrategy field.
func (o *RunExtractionRequest) SetStorageStrategy(v string) {
	o.StorageStrategy.Set(&v)
}

// SetStorageStrategyNil sets the value for StorageStrategy to be an explicit nil
func (o *RunExtractionRequest) SetStorageStrategyNil() {
	o.StorageStrategy.Set(nil)
}

// UnsetStorageStrategy ensures that no value is present for StorageStrategy, not even an explicit nil
func (o *RunExtractionRequest) UnsetStorageStrategy() {
	o.StorageStrategy.Unset()
}

func (o RunExtractionRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o RunExtractionRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Url.IsSet() {
		toSerialize["url"] = o.Url.Get()
	}
	if o.Limit.IsSet() {
		toSerialize["limit"] = o.Limit.Get()
	}
	if o.DateFrom.IsSet() {
		toSerialize["dateFrom"] = o.DateFrom.Get()
	}
	if o.DateTo.IsSet() {
		toSerialize["dateTo"] = o.DateTo.Get()
	}
	if o.DateRangeExpression.IsSet() {
		toSerialize["dateRangeExpression"] = o.DateRangeExpression.Get()
	}
	if o.StorageStrategy.IsSet() {
		toSerialize["storageStrategy"] = o.StorageStrategy.Get()
	}
	return toSerialize, nil
}

type NullableRunExtractionRequest struct {
	value *RunExtractionRequest
	isSet bool
}

func (v NullableRunExtractionRequest) Get() *RunExtractionRequest {
	return v.value
}

func (v *NullableRunExtractionRequest) Set(val *RunExtractionRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableRunExtractionRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableRunExtractionRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRunExtractionRequest(val *RunExtractionRequest) *NullableRunExtractionRequest {
	return &NullableRunExtractionRequest{value: val, isSet: true}
}

func (v NullableRunExtractionRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRunExtractionRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
